/**************************************************************************
 *
 *	xfile.h : أѤΥե롦ꥹɽġ
 *
 *	Version1.0	for Sony-NEWS	(NEWS-OS Release3.3a:UNIX 4.3BSD/X11R3)
 *					Copyright1991	Arakawa Laboratry(Nobuyuki Maruichi)
 *	Version1.1	for FM TOWNS II	(TOWNS Linux 0.973:Linux/X11R5)
 *					Copyright1993	Nobuyuki Maruichi
 *
 *				Nobuyuki Maruichi漼1991
 *
 **************************************************************************
 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <signal.h>
#include <pwd.h>
#include <grp.h>
/* ls include files  */
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dir.h>

#ifndef	XFILE_H
#define	XFILE_H

/***************************************************
 *	եʸstat¤
 *	С
 *		size_kb
 *			filename; ե򼨤ʸ
 *		stat_buf; 		stat¤
 ***************************************************/
typedef struct _FileInfo {
	char *size_kb;			/* ե륵ʣˣ¡ */
	char *attr;				/* ե° */
	char *link;				/* 󥯿 */
	char *user;				/* 桼ID롼ID */
	char *size;				/* ե륵bytes */
	char *date;				/* եκǽѹ */
	char *filename;			/* ե̾ */
	struct stat stat_buf;		/* Ρɤξ빽¤ */
} FileInfo;

/*****************************************************
 *	ꥹȷʻȹ¤
 *	С
 *		pos;	ե򼨤¤ΤؤΥݥ
 *		next;	ι¤ΤؤΥݥ
 *****************************************************/
typedef struct _FileLink {
	FileInfo *pos;				/* եؤΥݥ */
	struct _FileLink *next;		/* ι¤ΤؤΥݥ */
} FileLink;

/*************************************************************
 *	DirInfo ǥ쥯ȥ¤
 *	С
 *		searchingPath;	ǥ쥯ȥΥѥ̾
 *		nameList;		ι¤ΤؤΥݥ
 *		linkedInfo;		ե򼨤¤ΤؤΥݥ
 *************************************************************/
typedef struct _DirInfo {
	char *searchingPath;		/* ǥ쥯ȥΥѥ̾ */
	char **nameList;			/* եꥹȡʸ */
	FileInfo **infoList;		/* եؤΥݥ */
	FileLink *linkedInfo;		/* ե󷲤ؤΥݥ   */
	Widget dirWidget;			/* ǥ쥯ȥɽå */
	Widget fileWidget;			/* ե̾ɽå   */
	Widget listWidget;			/* եꥹȡå */
} FileSelctorInfo;

void fileListSelect(Widget w, XtPointer client_data, XtPointer call_data);
void remakeFileSelector(FileSelctorInfo *infomation);
int ismeta(const char *meta, const char *name);

int ascii_comp(const void *file1, const void *file2);
int suffix_comp(const void *file1, const void *file2);
int date_comp(const void *file1, const void *file2);
int size_comp(const void *file1, const void *file2);

#endif	/* XFILE_H */
